var EasyUnicodeInput = {
  readingCode: false,
  storedCode: "0x",
  prefMeta: 1,
  prefChar: "'",

  KeyPress: function(event) {
    var localReturnValue = true;
    var tempNode = null;
    if (this.readingCode == true) {
      // Reading the 4 digit Unicode value
      var localCurrentChar = event.key;
      var localStoredCode = this.storedCode;
      if ((localCurrentChar == "Esc") || (localCurrentChar == "Escape") || (localCurrentChar == "Enter")) {
        this.readingCode = false; this.storedCode = "0x";
        tempNode = document.getElementById("easyUnicodeInputP");
        if (tempNode != null) { tempNode.parentNode.removeChild(tempNode); }
        tempNode = document.getElementById("easyUnicodeInputDIV");
        if (tempNode != null) { tempNode.parentNode.removeChild(tempNode); }
      } else {
        if (localCurrentChar == "Backspace") {
          localStoredCode = String(localStoredCode).substring(0,(String(localStoredCode).length -1));
          if (localStoredCode.length < 2) { localStoredCode = "0x"; }
        } else { localStoredCode = localStoredCode + localCurrentChar; }
        tempNode = document.getElementById("easyUnicodeInputP");
        if (tempNode == null) {
          var tempNode1 = document.createElement("div");
          tempNode1.setAttribute("id","easyUnicodeInputDIV");
          tempNode1.setAttribute("style","z-index:10; position:absolute; left:10px; top:10px; background-color:#ffffff; color:#000000;");
          var tempNode2 = document.createElement("p");
          tempNode2.setAttribute("id","easyUnicodeInputP");
          tempNode2.textContent = "Unicode: " + String(localStoredCode);
          tempNode1.appendChild(tempNode2);
          document.body.appendChild(tempNode1);
        } else { tempNode.textContent = "Unicode: " + String(localStoredCode); }
        if (localStoredCode.length >= 6) {
          localStoredCode = String.fromCharCode(localStoredCode);
          this.readingCode = false;
          this.storedCode = "0x";
          var localElement = document.activeElement;
          var localElementName = String(localElement.tagName).toUpperCase();
          tempNode = document.getElementById("easyUnicodeInputP");
          if (tempNode != null) { tempNode.parentNode.removeChild(tempNode); }
          tempNode = document.getElementById("easyUnicodeInputDIV");
          if (tempNode != null) { tempNode.parentNode.removeChild(tempNode); }
          if ((localElementName == "TEXTAREA") || (localElementName == "INPUT")) {
            var startPos = localElement.selectionStart;
            var endPos = localElement.selectionEnd;
            localElement.value = localElement.value.substring(0, startPos)+localStoredCode+localElement.value.substring(endPos, localElement.value.length);
            localElement.selectionStart = startPos + localStoredCode.length;
            localElement.selectionEnd = startPos + localStoredCode.length;
          }
        } else { this.storedCode = localStoredCode; }
      }
      event.preventDefault(); localReturnValue = false;
    } else {
      // Checking to see if Unicode input has been triggered
      var localMetaState = 0;
      if (event.ctrlKey == true) { localMetaState = localMetaState + 1;}
      if (event.altKey == true) { localMetaState = localMetaState + 2;}
      if (localMetaState > 0) {
        if ((localMetaState == EasyUnicodeInput.prefMeta) && (event.key == EasyUnicodeInput.prefChar)) {
          this.readingCode = true; this.storedCode = "0x";
          event.preventDefault(); localReturnValue = false;
          tempNode = document.getElementById("easyUnicodeInputP");
          if (tempNode == null) {
            var tempNode1 = document.createElement("div");
            tempNode1.setAttribute("id","easyUnicodeInputDIV");
            tempNode1.setAttribute("style","z-index:10; position:absolute; left:10px; top:10px; background-color:#ffffff; color:#000000;");
            var tempNode2 = document.createElement("p");
            tempNode2.setAttribute("id","easyUnicodeInputP");
            tempNode2.textContent = "Unicode: "
            tempNode1.appendChild(tempNode2);
            document.body.appendChild(tempNode1);
          }
        }
      }
    }
    return localReturnValue;
  }
};

window.addEventListener("keypress", function(e) { EasyUnicodeInput.KeyPress(e); }, true);
